;*****************************************************************
; Hano 1.0 (C) 2001 David Champelovier
;*****************************************************************

  include "flib.h"
  include "tios.h"
  include "graphlib.h"

  xdef   _main
  xdef   _comment

_main:

	movem.l d0-d7/a0,-(a7)

; clears the screen, without the status bar
	jsr flib::clr_scr

; erases the ugly BUSY
	move.w #ACTIVITY_IDLE,-(a7)
	jsr tios::ST_busy
	add.l	#2,a7

; set the font
	move.w #2,-(a7)
	jsr tios::FontSetSys
	addq.l #2,a7

; draws the title
	move.w #4,-(a7)
	pea welcome(pc)
	move.w #4,-(a7)
	move.w #48,-(a7)
	jsr tios::DrawStrXY
	lea 10(a7),a7	
; welcome message on status bar
	pea m_welcome(pc)
	jsr tios::ST_showHelp
	addq.l #4,a7

; draws the default screen
	move.w #5,d0
	move.w #82,d1
	move.w #230,d2
	move.w #2,d3
	move.w #2,d4
	jsr graphlib::fill
	move.w #42,d0
	move.w #20,d1
	move.w #2,d2
	move.w #64,d3
	jsr graphlib::fill
	move.w #119,d0
	jsr graphlib::fill
	move.w #196,d0
	jsr graphlib::fill

; number of discs

	move.w #4,-(a7)
	pea m_number_of_discs(pc)
	move.w #100,-(a7)
	move.w #25,-(a7)
	jsr tios::DrawStrXY             ; how many discs ?
	lea 10(a7),a7	

	move.w #$FF,-(a7)
	move.w #$0,-(a7)
	move.w #$FF,-(a7)
	move.w #4,-(a7)
	move.w #100,-(a7)
	move.w #175,-(a7)
	move.w #0,-(a7)

	move.w #48,d4
	move.w #53,d3

	clr.w	tios::kb_globals+$1C       ; clear key buffer

change_nb:

	move.w d4,(a7)
	move.w #180,2(a7)
	jsr tios::DrawCharXY

	move.w d3,(a7)
	move.w #190,2(a7)
	jsr tios::DrawCharXY

wait_change:
	jsr idle_loop
	subi.w #338,d0
	bne not_up

; increases the number of discs
	subi.w #57,d3
	bne lower_than_nine
	moveq #49,d4
	moveq #48,d3
	bra change_nb
lower_than_nine:
	subi.w #49,d4
	bne ok_to_increase
	addi.w #7,d3
	bne ok_to_increase_bis

	pea m_too_big(pc)
	jsr tios::ST_showHelp
	addq.l #4,a7

	moveq #49,d4
	moveq #50,d3

	bra change_nb

ok_to_increase:
	moveq #48,d4
	addi.w #58,d3
	bra change_nb
ok_to_increase_bis:
	add.w #51,d3
	moveq #49,d4
	bra change_nb

not_up:
	subq.w #6,d0
	bne not_down

; decreases the number of discs
	subi.w #48,d3
	bne greater_than_zero
	moveq #48,d4
	moveq #57,d3
	bra change_nb
greater_than_zero:
	subi.w #48,d4
	bne not_too_small_bis
	subq.w #1,d3
	bne not_too_small
too_small:
	pea m_too_small(pc)
	jsr tios::ST_showHelp
	addq.l #4,a7
	moveq #48,d4
	moveq #49,d3
	bra wait_change
not_too_small:
	move.w #48,d4
	addi.w #48,d3
	bra change_nb
not_too_small_bis:
	moveq #49,d4
	addi.w #47,d3
	bra change_nb
not_down:
	addi.w #331,d0
	beq number_selected
not_return:
	subi #251,d0
	bne not_escape
	lea 14(a7),a7
	bra Esc_pressed
not_escape:
	pea m_key_number(pc)
	jsr tios::ST_showHelp
	addq.l #4,a7
	bra wait_change
number_selected:
	lea 14(a7),a7
	subi.w #48,d3
	subi.w #48,d4
	beq lower_than_ten
	addi.w #10,d3
lower_than_ten:
	move.w d3,nb_discs

; erases question
	move.w #0,d0
	move.w #100,d1
	move.w #230,d2
	move.w #20,d3
	move.w #1,d4
	jsr graphlib::fill

; choose initial tower
	move.w #4,-(a7)
	pea m_first_tower(pc)
	move.w #100,-(a7)
	move.w #25,-(a7)
	jsr tios::DrawStrXY             ; choose the first tower
	lea 10(a7),a7	

	moveq #0,d7                     ; default tower
	jsr choose_tower
	move.w d0,init_tower
; erases question
	move.w #0,d0
	move.w #100,d1
	move.w #230,d2
	move.w #20,d3
	move.w #1,d4
	jsr graphlib::fill
; set the font
	move.w #0,-(a7)
	jsr tios::FontSetSys
	addq.l #2,a7
; message for initial tower
	move.w #77,d0
	mulu init_tower(pc),d0
	addi.l #26,d0
	move.w #4,-(a7)
	pea m_from_here(pc)
	move.w #88,-(a7)
	move.w d0,-(a7)
	jsr tios::DrawStrXY
	lea 10(a7),a7
; set the font
	move.w #2,-(a7)
	jsr tios::FontSetSys
	addq.l #2,a7
; choose destination tower
	move.w #4,-(a7)
	pea m_second_tower(pc)
	move.w #100,-(a7)
	move.w #25,-(a7)
	jsr tios::DrawStrXY             ; choose the second tower
	lea 10(a7),a7	
choose_second:
	jsr choose_tower
	cmp.w init_tower(pc),d0
	bne good_choice
	pea m_the_same(pc)
	jsr tios::ST_showHelp
	addq.l #4,a7
	bra choose_second
good_choice:
	move.w d0,dest_tower
; erases question
	move.w #0,d0
	move.w #100,d1
	move.w #230,d2
	move.w #20,d3
	move.w #1,d4
	jsr graphlib::fill
; set the font
	move.w #0,-(a7)
	jsr tios::FontSetSys
	addq.l #2,a7
; message for destination tower
	move.w #77,d0
	mulu dest_tower(pc),d0
	addi.l #28,d0
	move.w #4,-(a7)
	pea m_to_there(pc)
	move.w #88,-(a7)
	move.w d0,-(a7)
	jsr tios::DrawStrXY
	lea 10(a7),a7

; the center pixel of the initial tower
	move.w #77,d0                       ; space between two towers
	mulu init_tower(pc),d0              ; d0 : space between left tower
	                                    ;      and init_tower

; initialization of data
	move.w #0,nb_played

	lea data(pc),a0
	move.l #0,(a0)                      ; no disc on first tower
	add.l #16,a0
	move.l #0,(a0)                      ; no disc on second tower
	add.l #16,a0
	move.l #0,(a0)                      ; no disc on third tower

	move.l #16,d7                       ; space in data between two towers
	mulu init_tower(pc),d7
	lea data(pc),a4
	adda.l d7,a4                        ; a4 now points to the summit
	                                    ; of the initial tower
	                                    ; See **data** for details
	movea.l a4,a5
	adda.l #16,a5                       ; (a5-1) now points to the first place
	                                    ; on initial tower

; displays the discs
	addq.w #6,d0                        ; biggest disc x top-left corner
	move.w #77,d1                       ; biggest disc y top_left corner
	move.w #74,d2                       ; biggest disc width
	move.w #2,d3                        ; disc height
	move.w #2,d4                        ; color

	moveq #0,d5
	move.w nb_discs(pc),d5
	subq.w #1,d5                        ; counter for discs
	moveq #0,d6
	move.b #12,d6
display_init:
	jsr graphlib::fill                  ; displays one disc
	addq.w #3,d0                        ; new x top-left corner
	subq.w #5,d1                        ; new y top-left corner
	subq.w #6,d2                        ; new width
	move.b d6,-(a5)                     ; positionning disc in data
	subq.b #1,d6
	dbra d5,display_init                ; for all disc
	move.l a5,(a4)                      ; update for the summit of
	                                    ; initial tower (data)

; choose game mode
; set the font
	move.w #1,-(a7)
	jsr tios::FontSetSys
	addq.l #2,a7
; message for game mode
	move.w #4,-(a7)
	pea m_mode_1(pc)
	move.w #98,-(a7)
	move.w #10,-(a7)
	jsr tios::DrawStrXY
	lea 10(a7),a7	
	move.w #4,-(a7)
	pea m_mode_2(pc)
	move.w #110,-(a7)
	move.w #10,-(a7)
	jsr tios::DrawStrXY
	lea 10(a7),a7	
; waiting for key
key_mode:
	jsr idle_loop
	subi.w #268,d0
	bne not_F1
	moveq #0,d7
	bra mode_chosen
not_F1:
	subq.w #1,d0
	bne not_F2
	moveq #1,d7
	move.w #1,is_waiting
	move.w #6,slow
	bra mode_chosen
not_F2:
	subq.w #1,d0
	bne not_F3
	moveq #1,d7
	pea m_faster(pc)
	jsr tios::ST_showHelp
	addq.l #4,a7
	move.w #0,is_waiting
	bra mode_chosen
not_F3:
	pea m_choose_mode(pc)
	jsr tios::ST_showHelp
	addq.l #4,a7
	bra key_mode
mode_chosen:
; erases question
	move.w #0,d0
	move.w #95,d1
	move.w #230,d2
	move.w #22,d3
	move.w #1,d4
	jsr graphlib::fill

; who plays ?
	tst.l d7
	beq you

; the TI92 solves the problem
	move.w is_waiting(pc),d7
	beq fast
; calculates the number of turns to play
	move.l #1,d0
	move.w nb_discs(pc),d1
	lsl.l d1,d0
	subq.l #1,d0
	move.w d0,nb_to_play

; converts it in a decimal number
	move.w d0,-(a7)
	pea stdisc(pc)
	pea str_nb_to_play(pc)
	jsr tios::sprintf
	lea 10(a7),a7

; set the font
	move.w #1,-(a7)
	jsr tios::FontSetSys
	addq.l #2,a7

; displays the number of turns to play on the screen
	move.w #1,-(a7)
	pea str_nb_to_play(pc)
	move.w #113,-(a7)
	move.w #200,-(a7)
	jsr tios::DrawStrXY
	lea 8(a7),a7
; message
	pea aff_nb_to_play(pc)
	move.w #113,-(a7)
	move.w #150,-(a7)
	jsr tios::DrawStrXY
	lea 8(a7),a7
; message turns played
	pea aff_played(pc)
	move.w #105,-(a7)
	move.w #150,-(a7)
	jsr tios::DrawStrXY
	lea 8(a7),a7

; speed
	jsr aff_speed
	pea disp_speed
	move.w #109,-(a7)
	move.w #20,-(a7)
	jsr tios::DrawStrXY
	lea 10(a7),a7
	

; come on and play !
fast:
	move.l APD_INIT,APD_TIMER           ; reset APD timer (1)
	clr.w	APD_FLAG                      ; reset APD timer (2)

	move.w dest_tower(pc),-(a7)
	move.w init_tower(pc),-(a7)
	move.w nb_discs(pc),-(a7)
	jsr move
	addq #6,a7

	jsr idle_loop

	bra Esc_pressed

	clr.w	tios::kb_globals+$1C       ; clear key buffer

; displays help for towers
you:
; set the font
	move.w #2,-(a7)
	jsr tios::FontSetSys
	addq.l #2,a7
; draws the F1 key
	move.w #4,-(a7)
	pea m_F1_key(pc)
	move.w #103,-(a7)
	move.w #30,-(a7)
	jsr tios::DrawStrXY
	lea 10(a7),a7	
; draws the F2 key
	move.w #4,-(a7)
	pea m_F2_key(pc)
	move.w #103,-(a7)
	move.w #107,-(a7)
	jsr tios::DrawStrXY
	lea 10(a7),a7	
; draws the F3 key
	move.w #4,-(a7)
	pea m_F3_key(pc)
	move.w #103,-(a7)
	move.w #184,-(a7)
	jsr tios::DrawStrXY
	lea 10(a7),a7	

; main loop of the game *************************************************
game:
	pea m_choose_from(pc)
	jsr tios::ST_showHelp
	addq.l #4,a7

key_from:
	jsr idle_loop

	sub.w #268,d0
	beq F1_pressed                   ; F1 : first tower
	subq.w #1,d0
	beq F2_pressed                   ; F2 : second tower
	subq.w #1,d0
	beq F3_pressed                   ; F3 : third tower
	addq.w #6,d0
	beq Esc_pressed                  ; Esc : exit the game

	pea m_unknown_key(pc)
	jsr tios::ST_showHelp
	addq.l #4,a7

	bra key_from                     ; unknown key

F1_pressed:
	move.w #0,-(a7)                     ; from-tower on stack
	bra select_disc
F2_pressed:
	move.w #1,-(a7)
	bra select_disc
F3_pressed:
	move.w #2,-(a7)
select_disc:

	jsr data_of_tower                   ; searches information about the tower

	tst.l (a2)                          ; I have to do so because the 68000
	                                    ; Assembler I use (fargo 2.71.F2)
	                                    ; changes the previous move
	                                    ; into movea, which does not
	                                    ; change Z and N...
	bne tower_not_empty

; here the tower is empty, it should not have been selected
	pea m_no_disc(pc)
	jsr tios::ST_showHelp
	addq.l #6,a7                        ; 4 + 2 = pea + from-tower

	bra key_from
	
tower_not_empty:

	jsr prep_disc_from

; loop that makes the disc blink
	movem.l d0-d7/a0-a6,-(a7)
	pea m_choose_second(pc)
	jsr tios::ST_showHelp
	addq.l #4,a7
	movem.l (a7)+,d0-d7/a0-a6

test_apd_1:
	move.l APD_INIT,APD_TIMER           ; reset APD timer (1)
	clr.w	APD_FLAG                      ; reset APD timer (2)
blink:
	jsr graphlib::fill                  ; inverts the left part of the disc
	exg d0,d5
	jsr graphlib::fill                  ; inverts the right part of the disc
	exg d0,d5
	
	move.l #$FFFF,d7
wait:
	dbra d7,wait

	tst.w	APD_FLAG                      ; time for APD?
	beq test_key_1
; do APD
	trap #4
	bra test_apd_1

test_key_1:
	tst.w	tios::kb_globals+$1C          ; has a key been pressed?
	beq blink

	move.w tios::kb_globals+$1E,d6
	clr.w	tios::kb_globals+$1C          ; clear key buffer

	sub.w #268,d6
	beq F1_pressed_2                   ; F1 : first tower
	subq.w #1,d6
	beq F2_pressed_2                   ; F2 : second tower
	subq.w #1,d6
	beq F3_pressed_2                   ; F3 : third tower
	addq.w #6,d6
	beq Esc_pressed_2                  ; Esc : exit the game

	movem.l d0-d7/a0-a6,-(a7)
	pea m_unknown_key(pc)
	jsr tios::ST_showHelp
	addq.l #4,a7
	movem.l (a7)+,d0-d7/a0-a6

	bra test_apd_1                          ; unknown key

F1_pressed_2:
	move.w #0,-(a7)                    ; to-tower on the stack
	bra select_disc_2
F2_pressed_2:
	move.w #1,-(a7)
	bra select_disc_2
F3_pressed_2:
	move.w #2,-(a7)
	bra select_disc_2
Esc_pressed_2:
	addq.l #2,a7
	bra Esc_pressed

select_disc_2:
; if the same tower has been chosen, this tower is not selected any more
	move.w (a7),d7
	cmp.w 2(a7),d7
	bne not_the_same
	move.w #2,d4                       ; Color black
	jsr graphlib::fill                 ; redraws the disc
	exg d0,d5
	jsr graphlib::fill
	addq.l #4,a7                       ; the two towers had been pushed on the stack
	bra game

not_the_same:

	jsr data_of_tower                   ; searches information about the tower

	tst.l (a2)                          ; same remark as before
	beq move_OK                         ; empty : OK

; if not empty, we have to test if disc is bigger
	move.b (a3),d7
	cmp.b (a5),d7
	bgt move_OK

; disc is smaller
	movem.l d0-d7/a0-a6,-(a7)
	pea m_smaller(pc)
	jsr tios::ST_showHelp
	addq.l #4,a7
	movem.l (a7)+,d0-d7/a0-a6
	addq.l #2,a7
	bra blink                           ; return to second disc selection

move_OK:
	jsr draw_disc_to                    ; it is time to move the disc

	addq.l #4,a7

; tests if finished
	move.w #16,d0
	mulu init_tower(pc),d0
	lea data(pc),a0
	adda.l d0,a0
	tst.l (a0)
	bne game                     ; tower is not yet empty... play again !
	move.w #16,d0
	moveq #3,d1
	sub.w init_tower(pc),d1
	sub.w dest_tower(pc),d1
	mulu d1,d0
	lea data(pc),a0
	adda.l d0,a0
	tst.l (a0)
	bne game                     ; tower is not yet empty

; WELL DONE !
; erases [F1] [F2] [F3]
	move.w #0,d0
	move.w #95,d1
	move.w #230,d2
	move.w #22,d3
	move.w #1,d4
	jsr graphlib::fill
; set the font
	move.w #2,-(a7)
	jsr tios::FontSetSys
	addq.l #2,a7
; draws the well-done message
	move.w #4,-(a7)
	pea m_well_done(pc)
	move.w #102,-(a7)
	move.w #30,-(a7)
	jsr tios::DrawStrXY
	lea 10(a7),a7	
; clears the status line
	pea m_no_message(pc)
	jsr tios::ST_showHelp
	addq.l #4,a7

	jsr idle_loop

Esc_pressed:
; restores the ugly BUSY, if not
; BUSY stays on the screen when
; everything is finished...
	move.w #ACTIVITY_BUSY,-(a7)
	jsr tios::ST_busy
	add.l	#2,a7

	movem.l (a7)+,d0-d7/a0
	rts

;*****************************************************************************
;  data_of_tower(WORD tower)
;*****************************************************************************
; find data about a tower, and puts it in a2 and a3
;
;      tower : 0, 1, or 2 pushed on stack
; return
;      a2.l : points to the address of the smallest disc of the tower
;      a3.l : = (a2). if the tower is empty, a3 = 0 else address of the
;             smallest disc
; WARNING :   d7  : used and not saved by the program
;*****************************************************************************
data_of_tower:
	moveq.l #16,d7                       ; space in data between two towers
	mulu 4(a7),d7                       ; jsr has put an address on stack
	lea data(pc),a2
	adda.l d7,a2
	move.l (a2),a3
	rts

;*****************************************************************************
;  prep_disc_from(WORD tower)
;*****************************************************************************
; prepares values in d0-d5 in order to be used by graphlib::fill
;    to display or erase a from-disc
; PRECONDITION: data_of_tower has to be ran before prep_disc, with
;    the same tower on the stack. (a2 and a3 positionned).
;    a2 and a3 are moved to a4 and a5
;
;     tower : 0, 1, or 2 pushed on stack
; return
;     d0 : x top-left pixel of selected disc
;     d1 : y top-left pixel of selected disc
;     d2 : width of half of selected disc
;     d3 : height
;     d4 : color
;     d5 : x top-left pixel of the right half of the disc
;*****************************************************************************
prep_disc_from:
	move.l a2,a4                          ; saves data
	move.l a3,a5

	move.w #77,d0                       ; space between two towers
	mulu 4(a7),d0
	add.w #42,d0

	moveq #0,d1
	move.b (a3),d1
	mulu #3,d1
	sub.w d1,d0                         ; d0 : x top-left pixel of selected disc

	move.l a3,d1
	sub.l a2,d1
	subq.w #4,d1
	mulu #5,d1
	add.w #22,d1                        ; d1 : y top-left pixel of selected disc

	moveq #0,d2
	move.b (a3),d2
	mulu #3,d2
	subq.w #1,d2                        ; d2 : width of half of selected disc

	move.l d0,d5
	add.l d2,d5
	addq.l #4,d5                        ; d5 : x top-left pixel of the right
	                                    ;      half of the disc.

	moveq #2,d3                         ; d3 : height

	moveq #0,d4                         ; d4 : Video Invert

	rts

;*****************************************************************************
;  draw_disc_to(WORD tower)
;*****************************************************************************
; * erases the disc on the initial tower
; * draws the disc on the new tower
; * updates data on initial and destination tower
; 
; PRECONDITIONS: 
; * prep_disc_from has to be run before draw_disc_to
; * d0,d1,d2,d5 and a2,a3,a4,a5 not modified since
; * data_of_tower has to be run before, for destination tower
; * of course initial and destination tower cannot be the same...
;
;   tower : 0, 1, or 2 on stack
;*****************************************************************************
draw_disc_to:
	move.w #1,d4                        ; Color white
	jsr graphlib::fill
	exg d0,d5
	jsr graphlib::fill                  ; disc removed from initial position

	move.w #77,d0                       ; space between two towers
	mulu 4(a7),d0
	add.w #42,d0

	moveq #0,d1
	move.b (a5),d1
	mulu #3,d1
	sub.w d1,d0                         ; d0 : x top-left pixel of selected disc

	moveq #0,d2
	move.b (a5),d2
	mulu #6,d2
	addq.w #2,d2                        ; d2 : width of half of selected disc

	tst.l (a2)
	beq destination_empty

	move.l a3,d1
	sub.l a2,d1
	subq.w #4,d1
	mulu #5,d1
	add.w #17,d1                        ; d1 : y top-left pixel of selected disc

	bra destination

destination_empty:

	move.w #77,d1

destination:
	moveq #2,d3                         ; d3 : height
	moveq #2,d4                         ; Color black

	jsr graphlib::fill

; data update
	tst.l (a2)
	bne to_tower_not_empty
	move.l a2,a3
	adda.l #16,a3
	move.l a3,(a2)

to_tower_not_empty:
	addq.l #1,(a4)                      ; new address for from-tower summit
	subq.l #1,(a2)                      ; new address for to-tower summit
	move.b (a5),-(a3)                   ; new disc on to-tower
	
; if (a4) = a4 + #16, no more disc on initial tower
	move.l (a4),d0
	sub.l a4,d0
	subi.l #16,d0
	bne there_are_some

	move.l #0,(a4)

there_are_some:

	rts

;***************************************************************************
; move(WORD n, WORD a, WORD b)       lets the calculator work !!!
;***************************************************************************
; MOVES n discS FROM a TO b
;***************************************************************************
d_n: SET 8
d_a: SET 10
d_b: SET 12
move:
	link a6,#0
	movem.w d2-d3,-(a7)

	move.w d_n(a6),d2
	subq.w #1,d2
	bne move_multiple

; move one disc from a tower to another
	move.w d_a(a6),-(a7)
	jsr data_of_tower
	jsr prep_disc_from
	move.w d_b(a6),(a7)
	jsr data_of_tower
	jsr draw_disc_to
	addq.l #2,a7

	move.w is_waiting(pc),d0             ; are we waiting or not 
	beq end_move                         ; between two moves ?

; perhaps too much time of inactivity
	tst.w	APD_FLAG	                   ; time for APD?
	beq not_time_for_apd

	trap #4
	move.l APD_INIT,APD_TIMER            ; reset APD timer (1)
	clr.w APD_FLAG                       ; reset APD timer (2)

not_time_for_apd:
; displays the number of turns played 
	move.w nb_played(pc),d5
	addq.l #1,d5
; converts it in a decimal number
	move.w d5,-(a7)
	pea stdisc(pc)
	pea str_nb_played(pc)
	jsr tios::sprintf
	lea 10(a7),a7
; set the font
	move.w #1,-(a7)
	jsr tios::FontSetSys
	addq.l #2,a7
; displays the number of turns played
	move.w #4,-(a7)
	pea str_nb_played(pc)
	move.w #105,-(a7)
	move.w #200,-(a7)
	jsr tios::DrawStrXY
	lea 10(a7),a7
; stores new nb_played
	move.w d5,nb_played



; let's wait...
	move.l #1,d7
	move.w slow(pc),d6
	lsl.l d6,d7
waiting:
	move.l #$FFF,d6
waiting_again:
	dbra d6,waiting_again
	dbra d7,waiting


	tst.w	tios::kb_globals+$1C           ; has a key been pressed?
	beq end_move
	move.w tios::kb_globals+$1E,d0
	clr.w	tios::kb_globals+$1C           ; clear key buffer

	move.l APD_INIT,APD_TIMER            ; reset APD timer (1)
	clr.w APD_FLAG                       ; reset APD timer (2)

	subi.w #264,d0                       ; Esc key
	bne not_esc
	move.w #0,is_waiting

	pea m_faster(pc)
	jsr tios::ST_showHelp
	addq.l #4,a7

	move.w #63,d0
	move.w #107,d1
	move.w #64,d2
	move.w #11,d3
	move.w #2,d4
	jsr graphlib::fill

	bra end_move

not_esc:
	move.w slow(pc),d1
	add.w #219,d0
	bne not_minus

	subi.l #9,d1                        ; - increases time to wait
	beq end_move
	addi.w #10,d1
	move.w d1,slow
	jsr aff_speed
	bra end_move

not_minus:
	addq.w #2,d0
	bne not_plus
	subq.l #1,d1                             ; + decreases time to wait
	beq end_move
	move.w d1,slow
	jsr aff_speed
	bra end_move

not_plus:
	pea m_plus_minus(pc)
	jsr tios::ST_showHelp
	addq.l #4,a7	
	bra end_move

move_multiple:                             ; move several towers
	moveq #3,d3
	sub.w d_a(a6),d3
	sub.w d_b(a6),d3
	move d3,-(a7)
	move.w d_a(a6),-(a7)
	move.w d2,-(a7)
	jsr move
	
	move.w #1,(a7)
	move.w d_b(a6),4(a7)
	jsr move

	move.w d2,(a7)
	move.w d3,2(a7)
	jsr move

	addq.l #6,a7

end_move:
	movem.w (a7)+,d2-d3
	unlk a6
	rts

;***************************************************************************
; aff_speed        based on the variable 'slow' which is between #1 and #9
;***************************************************************************
aff_speed:
	move.w #128,d0
	move.w #109,d1
	move.w #4,d2
	move.w #7,d3
	move.w #1,d4
	move.w #9,d5
	move.w slow(pc),d6

loop_speed:
	jsr graphlib::fill
	subq.w #1,d6
	bne do_not_change
	move.w #2,d4
do_not_change:
	subi.l #7,d0
	dbra d5,loop_speed

	move.w #63,d0
	move.w #107,d1
	move.w #118,d2
	jsr graphlib::vert
	move.w #127,d0
	jsr graphlib::vert
	move.w #2,d3
	move.w #63,d0
	move.w #127,d2
	move.w #107,d1
	jsr graphlib::horiz
	move.w #118,d1
	jsr graphlib::horiz

	rts

;***************************************************************************
; choose_tower            puts in d0 the tower chosen
;***************************************************************************
choose_tower:
	move.w #50,d1
	move.w #2,d2
	move.w #15,d3
	move.w #0,d6
move_tower:
; erases the previous
	move.w #2,d4
	move.w #77,d0
	mulu d6,d0
	addi.w #42,d0
	jsr graphlib::fill
; draws the new
	move.w #1,d4
	move.w #77,d0
	mulu d7,d0
	addi.w #42,d0
	jsr graphlib::fill
	jsr idle_loop
	subi.w #337,d0
	bne not_left
	move.w d7,d6
	tst.w d7
	beq zero
	subq.w #1,d7
	bra move_tower
zero:
	moveq #2,d7
	bra move_tower
not_left:
	subi.w #3,d0
	bne not_right
	move.w d7,d6
	subq.w #2,d7
	beq two
	addq.w #3,d7
	bra move_tower
two:
	moveq #0,d7
	bra move_tower
not_right:
	addi.w #327,d0
	bne not_enter
	move.w #2,d4
	move.w #77,d0
	mulu d7,d0
	addi.w #42,d0
	jsr graphlib::fill
	bra end_choose
not_enter:
	movem.w d0-d7,-(a7)
	pea m_left_right(pc)
	jsr tios::ST_showHelp
	addq.l #4,a7
	movem.w (a7)+,d0-d7
	bra move_tower
end_choose:
	move.w d7,d0
	rts

;*********************************************************************
; redefinition of idle_loop, because BUSY looks ugly on the status bar
;*********************************************************************
idle_loop:
	movem.l	a0-a6/d1-d7,-(a7)
idle_start:
	move.l	APD_INIT,APD_TIMER	; reset APD timer (1)
	clr.w	APD_FLAG		; reset APD timer (2)
wait_idle:
	tst.w	APD_FLAG		; time for APD?
	bne	do_apd
	tst.w	tios::kb_globals+$1C	; has a key been pressed?
	beq	wait_idle
	move.l	APD_INIT,APD_TIMER	; reset APD timer (1)
	move.w	tios::kb_globals+$1E,d0
	clr.w	tios::kb_globals+$1C	; clear key buffer
try_key_off:
	cmp.w	#$210B,d0
	bne	not_key_off
	bra	do_apd
not_key_off:
	movem.l	(a7)+,a0-a6/d1-d7
	rts
do_apd:
	trap	#4
	bra	idle_start


;***************************************************************************
;********************************* DATA ************************************
;***************************************************************************

nb_discs: dc.w 0                  ; Number of discs, between 1 and 12
init_tower: dc.w 0                ; Initial Tower, 0, 1 or 2
dest_tower: dc.w 0                ; Destination Tower, the tower where all the
                                  ;   discs have to be moved

is_waiting: dc.w 0                ; waiting or not dudisc automatic solve
slow: dc.w 0                      ; time to wait dudisc automatic solve (1-8)

nb_to_play: dc.w 0                ; number of turns to solve the problem
nb_played: dc.w 0                 ; number of turns already played

stdisc: dc.b "%d",0               ; to display an int with sprintf

aff_nb_to_play: dc.b "To play:",0
aff_played: dc.b "Played :",0

disp_speed: dc.b "Speed:",0

m_no_disc: dc.b "There is no disc on this tower !!!",0
m_choose_from: dc.b "Please choose a tower...",0
m_unknown_key: dc.b "Unknown key... Try F1,F2,F3 or Esc to quit",0
m_smaller: dc.b "Well, you can't move a disc on a smaller one !!!",0
m_choose_second: dc.b "Please choose destination tower...",0

m_from_here: dc.b "from here...",0
m_to_there: dc.b "to there !",0

m_number_of_discs: dc.b "How many discs ?",0
m_too_small: dc.b "Not less than one disc...",0
m_too_big: dc.b "Not more than 12 discs...",0

m_first_tower: dc.b "Choose the first tower...",0
m_second_tower: dc.b "...and choose the second !",0
m_the_same: dc.b "You have already chosen this tower !!!",0
m_left_right: dc.b "Use Left/Right to change tower, Enter to finish",0

m_key_number: dc.b "press UP/DOWN to change, ENTER to save, ESC to quit",0

m_plus_minus: dc.b "press +/- to change speed, ESC to run faster",0

m_mode_1: dc.b "Mode : [F1] Normal  [F2] TI",0
m_mode_2: dc.b "       [F3] TI Fast",0
m_choose_mode: dc.b "Select mode with F1, F2 or F3",0

m_F1_key: dc.b "[F1]",0
m_F2_key: dc.b "[F2]",0
m_F3_key: dc.b "[F3]",0

m_faster: dc.b "Faster ? you can't !!!",0

m_welcome: dc.b "Hano 1.0 (C) 2001/01/02 david@champelovier.com",0

m_well_done: dc.b "Well done !",0

m_no_message: dc.b 0

welcome: dc.b "Les tours de Hano",0

; data for storage of disc positions :
;
; data: T0   LBBBBBBBBBBBB          (16 bytes)
;       T1   LBBBBBBBBBBBB          (16 bytes)
;       T2   LBBBBBBBBBBBB          (16 bytes)
;
;  where L points to the byte representing the current summit of the tower
;        each B is a byte coding a disc. The discs are added from high to low
;        addresses (from right to left on the schema). The value of B is 
;        1 for the smallest disc and 12 for the biggest
data  ds.l 4
	ds.b 12
	ds.l 4
	ds.b 12
	ds.l 4
	ds.b 12

str_nb_to_play: ds.b 5            ;  max 4095 => 5 characters
str_nb_played: ds.b 5

_comment: dc.b "Hano v1.0 by DC 2001",0

       end
